;======================================================================
;
;USB SFR BIT MASKS
;
;========================================================================
;                                931Masks.inc
;

;
;=======================================================================*/
;

;T2CON   equ    0C8h        ; Already defined within 251 assembler.
;RCAP2L  equ    0CAh        ; Already defined within 251 assembler.
;RCAP2H  equ    0CBh        ; Already defined within 251 assembler.
CR      equ     0Dh
LF      equ     0Ah
NUL     equ    00h

  HFRTMRL  EQU     0B5h
  HFRTMRH  EQU     0B6h


        USB_IEN1            equ   0B1h
;        LED0                equ   0F8h
;        LED1                equ   0F9h
;        LED2                equ   0FAh
;        LED3                equ   0FBh

;       930Ax SFR bits

        BIT7_SET_MASK       equ   080h
        BIT7_CLR_MASK       equ   07Fh
        BIT6_SET_MASK       equ   040h
        BIT6_CLR_MASK       equ   0BFh
        BIT5_SET_MASK       equ   020h
        BIT5_CLR_MASK       equ   0DFh
        BIT4_SET_MASK       equ   010h
        BIT4_CLR_MASK       equ   0EFh
        BIT3_SET_MASK       equ   08h
        BIT3_CLR_MASK       equ   0F7h
        BIT2_SET_MASK       equ   04h
        BIT2_CLR_MASK       equ   0FBh
        BIT1_SET_MASK       equ   02h
        BIT1_CLR_MASK       equ   0FDh
        BIT0_SET_MASK       equ   01h
        BIT0_CLR_MASK       equ   0FEh


        LC_SET_MASK:         equ   BIT5_SET_MASK
        LC_CLR_MASK:         equ   BIT5_CLR_MASK
        PD_SET_MASK:         equ   BIT1_SET_MASK
        PD_CLR_MASK:         equ   BIT1_CLR_MASK

        LC_BIT:              equ   "5"
        PD_BIT:              equ   "1"

        GRWU_SET_MASK:       equ   BIT2_SET_MASK
        GRWU_CLR_MASK:       equ   BIT2_CLR_MASK
        GRSM_SET_MASK:       equ   BIT1_SET_MASK
        GRSM_CLR_MASK:       equ   BIT1_CLR_MASK
        GSUS_SET_MASK:       equ   BIT0_SET_MASK
        GSUS_CLR_MASK:       equ   BIT0_CLR_MASK

        GRWU_BIT             equ "2"
        GRSM_BIT             equ "1"
        GSUS_BIT             equ "0"

        SFACK_SET_MASK      equ   BIT7_SET_MASK
        SFACK_CLR_MASK      equ   BIT7_CLR_MASK
        ASOF_SET_MASK       equ   BIT6_SET_MASK
        ASOF_CLR_MASK       equ   BIT6_CLR_MASK
        SOFIE_SET_MASK      equ   BIT5_SET_MASK
        SOFIE_CLR_MASK      equ   BIT5_CLR_MASK
        FTLOCK_SET_MASK     equ   BIT4_SET_MASK
        FTLOCK_CLR_MASK     equ   BIT4_CLR_MASK
        SOFDIS_SET_MASK     equ   BIT3_SET_MASK
        SOFDIS_CLR_MASK     equ   BIT3_CLR_MASK

        SFACK_BIT   EQU     "7"
        ASOF_BIT    EQU     "6"
        SOFIE_BIT   EQU     "5"
        FTLOCK_BIT  EQU     "4"
        SOFODIS_BIT EQU     "3"


        FRXIE3_SET_MASK      equ   BIT7_SET_MASK
        FRXIE3_CLR_MASK      equ   BIT7_CLR_MASK
        FTXIE3_SET_MASK      equ   BIT6_SET_MASK
        FTXIE3_CLR_MASK      equ   BIT6_CLR_MASK
        FRXIE2_SET_MASK      equ   BIT5_SET_MASK
        FRXIE2_CLR_MASK      equ   BIT5_CLR_MASK
        FTXIE2_SET_MASK      equ   BIT4_SET_MASK
        FTXIE2_CLR_MASK      equ   BIT4_CLR_MASK
        FRXIE1_SET_MASK      equ   BIT3_SET_MASK
        FRXIE1_CLR_MASK      equ   BIT3_CLR_MASK
        FTXIE1_SET_MASK      equ   BIT2_SET_MASK
        FTXIE1_CLR_MASK      equ   BIT2_CLR_MASK
        FRXIE0_SET_MASK      equ   BIT1_SET_MASK
        FRXIE0_CLR_MASK      equ   BIT1_CLR_MASK
        FTXIE0_SET_MASK      equ   BIT0_SET_MASK
        FTXIE0_CLR_MASK      equ   BIT0_CLR_MASK

        FRXD3_SET_MASK      equ   BIT7_SET_MASK
        FRXD3_CLR_MASK      equ   BIT7_CLR_MASK
        FTXD3_SET_MASK      equ   BIT6_SET_MASK
        FTXD3_CLR_MASK      equ   BIT6_CLR_MASK
        FRXD2_SET_MASK      equ   BIT5_SET_MASK
        FRXD2_CLR_MASK      equ   BIT5_CLR_MASK
        FTXD2_SET_MASK      equ   BIT4_SET_MASK
        FTXD2_CLR_MASK      equ   BIT4_CLR_MASK
        FRXD1_SET_MASK      equ   BIT3_SET_MASK
        FRXD1_CLR_MASK      equ   BIT3_CLR_MASK
        FTXD1_SET_MASK      equ   BIT2_SET_MASK
        FTXD1_CLR_MASK      equ   BIT2_CLR_MASK
        FRXD0_SET_MASK      equ   BIT1_SET_MASK
        FRXD0_CLR_MASK      equ   BIT1_CLR_MASK
        FTXD0_SET_MASK      equ   BIT0_SET_MASK
        FTXD0_CLR_MASK      equ   BIT0_CLR_MASK


        RXSTL_SET_MASK      equ   BIT7_SET_MASK
        RXSTL_CLR_MASK      equ   BIT7_CLR_MASK
        TXSTL_SET_MASK      equ   BIT6_SET_MASK
        TXSTL_CLR_MASK      equ   BIT6_CLR_MASK
        CTLEP_SET_MASK      equ   BIT5_SET_MASK
        CTLEP_CLR_MASK      equ   BIT5_CLR_MASK
        RXSPM_SET_MASK      equ   BIT4_SET_MASK
        RXSPM_CLR_MASK      equ   BIT4_CLR_MASK
        RXIE_SET_MASK       equ   BIT3_SET_MASK
        RXIE_CLR_MASK       equ   BIT3_CLR_MASK
        RXEPEN_SET_MASK     equ   BIT2_SET_MASK
        RXEPEN_CLR_MASK     equ   BIT2_CLR_MASK
        TXIE_SET_MASK       equ   BIT1_SET_MASK
        TXIE_CLR_MASK       equ   BIT1_CLR_MASK
        TXEPEN_SET_MASK     equ   BIT0_SET_MASK
        TXEPEN_CLR_MASK     equ   BIT0_CLR_MASK



        ; RXSTAT
        RXSEQ_SET_MASK      equ   BIT7_SET_MASK
        RXSEQ_CLR_MASK      equ   BIT7_CLR_MASK
        RXSETUP_SET_MASK    equ   BIT6_SET_MASK
        RXSETUP_CLR_MASK    equ   BIT6_CLR_MASK
        STOVW_SET_MASK      equ   BIT5_SET_MASK
        STOVW_CLR_MASK      equ   BIT5_CLR_MASK
        EDOVW_SET_MASK      equ   BIT4_SET_MASK
        EDOVW_CLR_MASK      equ   BIT4_CLR_MASK
        RXDTO_SET_MASK      equ   BIT3_SET_MASK
        RXDTO_CLR_MASK      equ   BIT3_CLR_MASK
        RXVOID_SET_MASK     equ   BIT2_SET_MASK
        RXVOID_CLR_MASK     equ   BIT2_CLR_MASK
        RXERR_SET_MASK      equ   BIT1_SET_MASK
        RXERR_CLR_MASK      equ   BIT1_CLR_MASK
        RXERR_BIT           equ   "1"
        RXACK_SET_MASK      equ   BIT0_SET_MASK
        RXACK_CLR_MASK      equ   BIT0_CLR_MASK


        RXCLR_SET_MASK      equ   BIT7_SET_MASK
        RXCLR_CLR_MASK      equ   BIT7_CLR_MASK

        RXWS_SET_MASK       equ   BIT5_SET_MASK
        RXWS_CLR_MASK       equ   BIT5_CLR_MASK
        RXFFRC_SET_MASK     equ   BIT4_SET_MASK
        RXFFRC_CLR_MASK     equ   BIT4_CLR_MASK
        RXISO_SET_MASK      equ   BIT3_SET_MASK
        RXISO_CLR_MASK      equ   BIT3_CLR_MASK
        ARM_SET_MASK        equ   BIT2_SET_MASK
        ARM_CLR_MASK        equ   BIT2_CLR_MASK
        ADVWM_SET_MASK      equ   BIT1_SET_MASK
        ADVWM_CLR_MASK      equ   BIT1_CLR_MASK
        REVWP_SET_MASK      equ   BIT0_SET_MASK
        REVWP_CLR_MASK      equ   BIT0_CLR_MASK


        RXFIF1_SET_MASK     equ   BIT7_SET_MASK
        RXFIF1_CLR_MASK     equ   BIT7_CLR_MASK
        RXFIF1_BIT          equ   "7"
        RXFIF0_SET_MASK     equ   BIT6_SET_MASK
        RXFIF0_CLR_MASK     equ   BIT6_CLR_MASK
        RXFIF0_BIT          equ   "6"
        RXEMP_SET_MASK      equ   BIT3_SET_MASK
        RXEMP_CLR_MASK      equ   BIT3_CLR_MASK
        RXFULL_SET_MASK     equ   BIT2_SET_MASK
        RXFULL_CLR_MASK     equ   BIT2_CLR_MASK
        RXURF_SET_MASK      equ   BIT1_SET_MASK
        RXURF_CLR_MASK      equ   BIT1_CLR_MASK
        RXOVF_SET_MASK      equ   BIT0_SET_MASK
        RXOVF_CLR_MASK      equ   BIT0_CLR_MASK


        TXSEQ_SET_MASK      equ   BIT7_SET_MASK
        TXSEQ_CLR_MASK      equ   BIT7_CLR_MASK
        TXSOVW_SET_MASK     equ   BIT3_SET_MASK
        TXSOVW_CLR_MASK     equ   BIT3_CLR_MASK
        TXVOID_SET_MASK     equ   BIT2_SET_MASK
        TXVOID_CLR_MASK     equ   BIT2_CLR_MASK
        TXERR_SET_MASK      equ   BIT1_SET_MASK
        TXERR_CLR_MASK      equ   BIT1_CLR_MASK
        TXERR_BIT           equ   "1"
        TXACK_SET_MASK      equ   BIT0_SET_MASK
        TXACK_CLR_MASK      equ   BIT0_CLR_MASK


        TXCLR_SET_MASK      equ   BIT7_SET_MASK
        TXCLR_CLR_MASK      equ   BIT7_CLR_MASK
        FFSZ1_SET_MASK      equ   BIT6_SET_MASK
        FFSZ1_CLR_MASK      equ   BIT6_CLR_MASK
        FFSZ0_SET_MASK      equ   BIT5_SET_MASK
        FFSZ0_CLR_MASK      equ   BIT5_CLR_MASK
        TXISO_SET_MASK      equ   BIT3_SET_MASK
        TXISO_CLR_MASK      equ   BIT3_CLR_MASK
        ATM_SET_MASK        equ   BIT2_SET_MASK
        ATM_CLR_MASK        equ   BIT2_CLR_MASK
        ADVRM_SET_MASK      equ   BIT1_SET_MASK
        ADVRM_CLR_MASK      equ   BIT1_CLR_MASK
        REVRP_SET_MASK      equ   BIT0_SET_MASK
        REVRP_CLR_MASK      equ   BIT0_CLR_MASK



        TXFIF1_SET_MASK     equ   BIT7_SET_MASK
        TXFIF1_CLR_MASK     equ   BIT7_CLR_MASK
        TXFIF1_BIT          equ   "7"
        TXFIF0_SET_MASK     equ   BIT6_SET_MASK
        TXFIF0_CLR_MASK     equ   BIT6_CLR_MASK
        TXFIF0_BIT          equ   "6"
        TXEMP_SET_MASK      equ   BIT3_SET_MASK
        TXEMP_CLR_MASK      equ   BIT3_CLR_MASK
        TXFULL_SET_MASK     equ   BIT2_SET_MASK
        TXFULL_CLR_MASK     equ   BIT2_CLR_MASK
        TXURF_SET_MASK      equ   BIT1_SET_MASK
        TXURF_CLR_MASK      equ   BIT1_CLR_MASK
        TXOVF_SET_MASK      equ   BIT0_SET_MASK
        TXOVF_CLR_MASK      equ   BIT0_CLR_MASK
        HRWUPE_BIT  equ "6"

        HRWUPE_SET_MASK     equ   BIT6_SET_MASK
        HRWUPE_CLR_MASK     equ   BIT6_CLR_MASK
        EP1STL_SET_MASK     equ   BIT5_SET_MASK
        EP1STL_CLR_MASK     equ   BIT5_CLR_MASK
        EP1EN_SET_MASK      equ   BIT4_SET_MASK
        EP1EN_CLR_MASK      equ   BIT4_CLR_MASK
        OVISC_SET_MASK      equ   BIT3_SET_MASK
        OVISC_CLR_MASK      equ   BIT3_CLR_MASK
        LPSC_SET_MASK       equ   BIT2_SET_MASK
        LPSC_CLR_MASK       equ   BIT2_CLR_MASK
        OVI_SET_MASK        equ   BIT1_SET_MASK
        OVI_CLR_MASK        equ   BIT1_CLR_MASK
        LPS_SET_MASK        equ   BIT0_SET_MASK
        LPS_CLR_MASK        equ   BIT0_CLR_MASK


        DPSTAT_SET_MASK     equ   BIT7_SET_MASK
        DPSTAT_CLR_MASK     equ   BIT7_CLR_MASK
        DMSTAT_SET_MASK     equ   BIT6_SET_MASK
        DMSTAT_CLR_MASK     equ   BIT6_CLR_MASK
        LSSTAT_SET_MASK     equ   BIT5_SET_MASK
        LSSTAT_CLR_MASK     equ   BIT5_CLR_MASK
        PPSTAT_SET_MASK     equ   BIT4_SET_MASK
        PPSTAT_CLR_MASK     equ   BIT4_CLR_MASK
        PRSTAT_SET_MASK     equ   BIT3_SET_MASK
        PRSTAT_CLR_MASK     equ   BIT3_CLR_MASK
        PSSTAT_SET_MASK     equ   BIT2_SET_MASK
        PSSTAT_CLR_MASK     equ   BIT2_CLR_MASK
        PESTAT_SET_MASK     equ   BIT1_SET_MASK
        PESTAT_CLR_MASK     equ   BIT1_CLR_MASK
        PCSTAT_SET_MASK     equ   BIT0_SET_MASK
        PCSTAT_CLR_MASK     equ   BIT0_CLR_MASK


        LSSTAT_BIT          equ   "5"
        PPSTAT_BIT          equ   "4"
        PRSTAT_BIT          equ   "3"
        PSSTAT_BIT          equ   "2"
        PESTAT_BIT          equ   "1"
        PCSTAT_BIT          equ   "0"